package com.sw.activemq.consumer;

import com.sw.service.SnatchMaskService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Service;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.ObjectMessage;
import java.util.Date;
import java.util.Map;

@Service
@Slf4j
public class MessageConsumerService {

	@Autowired
	private SnatchMaskService snatchMaskService;

	@JmsListener(destination="mask")
	public void receiveMessage(Message info) {	// 进行消息接收处理
		System.out.println(new Date());
		log.info("【*** 接收消息 ***】--->info", info);
		if(info instanceof ObjectMessage){
			ObjectMessage objectMessage=(ObjectMessage) info;
			try {
				Map<String, Object> mesg = (Map) objectMessage.getObject();
				Integer mid = Integer.valueOf(mesg.get("mid").toString());
				Integer uid = Integer.valueOf(mesg.get("uid").toString());
				snatchMaskService.doDecrAndCreateOrder(uid, mid);
			} catch (JMSException e) {
				e.printStackTrace();
			}
		}
	}
}
